searchNodes=[{"type":"module","doc":"","title":"Freddy","ref":"Freddy.html"},{"type":"behaviour","doc":"An interface for AMQP layer","title":"Freddy.Adapter","ref":"Freddy.Adapter.html"},{"type":"callback","doc":"Acks a message","title":"Freddy.Adapter.ack/3","ref":"Freddy.Adapter.html#c:ack/3"},{"type":"callback","doc":"Binds given exchange to another exchange","title":"Freddy.Adapter.bind_exchange/4","ref":"Freddy.Adapter.html#c:bind_exchange/4"},{"type":"callback","doc":"Binds given queue to the exchange","title":"Freddy.Adapter.bind_queue/4","ref":"Freddy.Adapter.html#c:bind_queue/4"},{"type":"callback","doc":"Closes existing channel","title":"Freddy.Adapter.close_channel/1","ref":"Freddy.Adapter.html#c:close_channel/1"},{"type":"callback","doc":"Closes AMQP connection","title":"Freddy.Adapter.close_connection/1","ref":"Freddy.Adapter.html#c:close_connection/1"},{"type":"callback","doc":"Registers given pid as a consumer from a queue","title":"Freddy.Adapter.consume/4","ref":"Freddy.Adapter.html#c:consume/4"},{"type":"callback","doc":"Declares exchange of the given type on the channel","title":"Freddy.Adapter.declare_exchange/4","ref":"Freddy.Adapter.html#c:declare_exchange/4"},{"type":"callback","doc":"Declares queue with the given name on the channel","title":"Freddy.Adapter.declare_queue/3","ref":"Freddy.Adapter.html#c:declare_queue/3"},{"type":"callback","doc":"Deletes the given queue","title":"Freddy.Adapter.delete_queue/3","ref":"Freddy.Adapter.html#c:delete_queue/3"},{"type":"callback","doc":"Transforms a message received by a consumed pid into one of the well defined terms expected by consumers. The expected terms are:{:consume_ok, meta} - consume-ok message sent by the AMQP server when a consumer is started{:deliver, payload, meta} - an actual message from the queue being consumed{:cancel_ok, meta} - cancel-ok message sent by the AMQP server when a consumer is started{:cancel, meta} - cancel message sent by the AMQP server when a consumer has been unexpectedly closed{:return, payload meta} - return message sent by the AMQP server when message could not be routed:unknown - any other message","title":"Freddy.Adapter.handle_message/1","ref":"Freddy.Adapter.html#c:handle_message/1"},{"type":"callback","doc":"Links current process to a connection","title":"Freddy.Adapter.link_connection/1","ref":"Freddy.Adapter.html#c:link_connection/1"},{"type":"callback","doc":"Sets up a monitor on a channel","title":"Freddy.Adapter.monitor_channel/1","ref":"Freddy.Adapter.html#c:monitor_channel/1"},{"type":"callback","doc":"Nacks a message","title":"Freddy.Adapter.nack/3","ref":"Freddy.Adapter.html#c:nack/3"},{"type":"callback","doc":"Opens new channel on connection","title":"Freddy.Adapter.open_channel/1","ref":"Freddy.Adapter.html#c:open_channel/1"},{"type":"callback","doc":"Opens AMQP connection with given options. Return {:ok, connection} on success or {:error, reason} on failure.","title":"Freddy.Adapter.open_connection/1","ref":"Freddy.Adapter.html#c:open_connection/1"},{"type":"callback","doc":"Publishes a message to an exchange","title":"Freddy.Adapter.publish/5","ref":"Freddy.Adapter.html#c:publish/5"},{"type":"callback","doc":"Set up channel QoS","title":"Freddy.Adapter.qos/2","ref":"Freddy.Adapter.html#c:qos/2"},{"type":"callback","doc":"Registers given process as a return handler for the given channel","title":"Freddy.Adapter.register_return_handler/2","ref":"Freddy.Adapter.html#c:register_return_handler/2"},{"type":"callback","doc":"Rejects a message","title":"Freddy.Adapter.reject/3","ref":"Freddy.Adapter.html#c:reject/3"},{"type":"callback","doc":"Unbinds given queue to the exchange","title":"Freddy.Adapter.unbind_queue/4","ref":"Freddy.Adapter.html#c:unbind_queue/4"},{"type":"type","doc":"","title":"Freddy.Adapter.channel/0","ref":"Freddy.Adapter.html#t:channel/0"},{"type":"type","doc":"","title":"Freddy.Adapter.connection/0","ref":"Freddy.Adapter.html#t:connection/0"},{"type":"type","doc":"","title":"Freddy.Adapter.consumer_tag/0","ref":"Freddy.Adapter.html#t:consumer_tag/0"},{"type":"type","doc":"","title":"Freddy.Adapter.delivery_tag/0","ref":"Freddy.Adapter.html#t:delivery_tag/0"},{"type":"type","doc":"","title":"Freddy.Adapter.error/0","ref":"Freddy.Adapter.html#t:error/0"},{"type":"type","doc":"","title":"Freddy.Adapter.exchange_name/0","ref":"Freddy.Adapter.html#t:exchange_name/0"},{"type":"type","doc":"","title":"Freddy.Adapter.exchange_type/0","ref":"Freddy.Adapter.html#t:exchange_type/0"},{"type":"type","doc":"","title":"Freddy.Adapter.meta/0","ref":"Freddy.Adapter.html#t:meta/0"},{"type":"type","doc":"","title":"Freddy.Adapter.options/0","ref":"Freddy.Adapter.html#t:options/0"},{"type":"type","doc":"","title":"Freddy.Adapter.payload/0","ref":"Freddy.Adapter.html#t:payload/0"},{"type":"type","doc":"","title":"Freddy.Adapter.queue_name/0","ref":"Freddy.Adapter.html#t:queue_name/0"},{"type":"type","doc":"","title":"Freddy.Adapter.queue_opts/0","ref":"Freddy.Adapter.html#t:queue_opts/0"},{"type":"type","doc":"","title":"Freddy.Adapter.routing_key/0","ref":"Freddy.Adapter.html#t:routing_key/0"},{"type":"module","doc":"Special no-op Freddy adapter designed to be used in automated tests instead of real AMQP connection.Exampleiex&gt; alias Freddy.{Connection, Core.Exchange, Adapter.Sandbox} iex&gt; {:ok, conn} = Connection.start_link(adapter: :sandbox) iex&gt; {:ok, channel} = Connection.open_channel(conn) iex&gt; :ok = Exchange.declare(%Exchange{name: &quot;test&quot;}, channel) iex&gt; {:ok, pid} = Connection.get_connection(conn) iex&gt; Sandbox.history(pid) [ link_connection: [#PID&lt;0.226.0&gt;], open_channel: [#PID&lt;0.226.0&gt;], monitor_channel: [#PID&lt;0.228.0&gt;], declare_exchange: [#PID&lt;0.228.0&gt;, &quot;test&quot;, :direct, []] ]","title":"Freddy.Adapter.Sandbox","ref":"Freddy.Adapter.Sandbox.html"},{"type":"function","doc":"Sends a message to the process specified by dest whenever an event occurs.The messages will be tuples {event, args} where event is an atom that corresponds to a callback in the Freddy.Adapter module. args is a list of arguments passed to the callback.dest may be either a PID or a locally registered name (atom).Exampleiex&gt; alias Freddy.{Connection, Core.Exchange, Adapter.Sandbox} iex&gt; {:ok, conn} = Connection.start_link(adapter: :sandbox) iex&gt; {:ok, pid} = Connection.get_connection(conn) iex&gt; :ok = Sandbox.add_listener(pid, self()) iex&gt; {:ok, channel} = Connection.open_channel(conn) iex&gt; :ok = Exchange.declare(%Exchange{name: &quot;test&quot;}, channel) iex&gt; flush() {:open_channel, [#PID&lt;0.226.0&gt;]} {:monitor_channel, [#PID&lt;0.228.0&gt;]} {:declare_exchange, [#PID&lt;0.228.0&gt;, &quot;test&quot;, :direct, []]}","title":"Freddy.Adapter.Sandbox.add_listener/2","ref":"Freddy.Adapter.Sandbox.html#add_listener/2"},{"type":"function","doc":"Get history of events from connection. Events can be filtered by type, for example, if one wants to get only history of messages, published over given connection, he should call history(connection, :publish). Filter by multiple event types is supported.Passing true as a third argument will erase entire history after returning it.","title":"Freddy.Adapter.Sandbox.history/3","ref":"Freddy.Adapter.Sandbox.html#history/3"},{"type":"function","doc":"Sets a response for open_channel/1 function. If set to :ok, the function will return a tuple {:ok, channel_pid} (default behaviour).","title":"Freddy.Adapter.Sandbox.on_open_channel/2","ref":"Freddy.Adapter.Sandbox.html#on_open_channel/2"},{"type":"function","doc":"Removes a listener previously registered with add_listener/2.","title":"Freddy.Adapter.Sandbox.remove_listener/2","ref":"Freddy.Adapter.Sandbox.html#remove_listener/2"},{"type":"module","doc":"Stable AMQP connection.","title":"Freddy.Connection","ref":"Freddy.Connection.html"},{"type":"function","doc":"Closes an AMQP connection. This will cause process to reconnect.","title":"Freddy.Connection.close/2","ref":"Freddy.Connection.html#close/2"},{"type":"function","doc":"Returns underlying connection PID","title":"Freddy.Connection.get_connection/1","ref":"Freddy.Connection.html#get_connection/1"},{"type":"function","doc":"Opens a new AMQP channel","title":"Freddy.Connection.open_channel/2","ref":"Freddy.Connection.html#open_channel/2"},{"type":"function","doc":"Start a new AMQP connection.connection_opts can be supplied either as keyword list - in this case connection will be established to one RabbitMQ server - or as a list of keyword list - in this case Freddy.Connection will first attempt to establish connection to the host specified by the first element of the list, then to the second, if the first one has failed, and so on.Options:adapter - Freddy adapter. Can be any module, but also can be passed as an alias :amqp or :sandox:backoff - Backoff can be specified either as a 1-arity function that accepts attempt number (starting from 1) , or as a tuple {module, function, arguments} (in this case attempt number will appended to the arguments) or as a backoff config.:host - The hostname of the broker (defaults to &quot;localhost&quot;):port - The port the broker is listening on (defaults to 5672):username - The name of a user registered with the broker (defaults to &quot;guest&quot;):password - The password of user (defaults to &quot;guest&quot;):virtual_host - The name of a virtual host in the broker (defaults to &quot;/&quot;):channel_max - The channel_max handshake parameter (defaults to 0):frame_max - The frame_max handshake parameter (defaults to 0):heartbeat - The hearbeat interval in seconds (defaults to 10):connection_timeout - The connection timeout in milliseconds (defaults to 5000):ssl_options - Enable SSL by setting the location to cert files (defaults to none):client_properties - A list of extra client properties to be sent to the server, defaults to []:socket_options - Extra socket options. These are appended to the default options. See :inet.setopts/2 and :gen_tcp.connect/4 for descriptions of the available options.Backoff configurationBackoff config specifies how intervals should be calculated between reconnection attempts.Available options:type - should be :constant, :normal or :jitter. When type is set to :constant, interval between all reconnection attempts is the same, defined by option :start. When type is set to :normal, intervals between reconnection attempts are incremented exponentially. When type is set to :jitter, intervals are also incremented exponentially, but with randomness or jitter (see :backoff.rand_increment/2). Defaults to :jitter.:start - an initial backoff interval in milliseconds. Defaults to 1000.:max - specifies maximum backoff interval in milliseconds. Defaults to 10000.","title":"Freddy.Connection.start_link/2","ref":"Freddy.Connection.html#start_link/2"},{"type":"function","doc":"Stops the connection process","title":"Freddy.Connection.stop/1","ref":"Freddy.Connection.html#stop/1"},{"type":"type","doc":"Freddy adapter. Can be any module, but also can be passed as an alias :amqp or :sandox","title":"Freddy.Connection.adapter/0","ref":"Freddy.Connection.html#t:adapter/0"},{"type":"type","doc":"","title":"Freddy.Connection.connection/0","ref":"Freddy.Connection.html#t:connection/0"},{"type":"type","doc":"Keyword list of AMQP connection params.Options:adapter - Freddy adapter. Can be any module, but also can be passed as an alias :amqp or :sandox:backoff - Backoff can be specified either as a 1-arity function that accepts attempt number (starting from 1) , or as a tuple {module, function, arguments} (in this case attempt number will appended to the arguments) or as a backoff config.:host - The hostname of the broker (defaults to &quot;localhost&quot;):port - The port the broker is listening on (defaults to 5672):username - The name of a user registered with the broker (defaults to &quot;guest&quot;):password - The password of user (defaults to &quot;guest&quot;):virtual_host - The name of a virtual host in the broker (defaults to &quot;/&quot;):channel_max - The channel_max handshake parameter (defaults to 0):frame_max - The frame_max handshake parameter (defaults to 0):heartbeat - The hearbeat interval in seconds (defaults to 10):connection_timeout - The connection timeout in milliseconds (defaults to 5000):ssl_options - Enable SSL by setting the location to cert files (defaults to none):client_properties - A list of extra client properties to be sent to the server, defaults to []:socket_options - Extra socket options. These are appended to the default options. See :inet.setopts/2 and :gen_tcp.connect/4 for descriptions of the available options.","title":"Freddy.Connection.connection_params/0","ref":"Freddy.Connection.html#t:connection_params/0"},{"type":"type","doc":"","title":"Freddy.Connection.connection_spec/0","ref":"Freddy.Connection.html#t:connection_spec/0"},{"type":"type","doc":"","title":"Freddy.Connection.connection_uri/0","ref":"Freddy.Connection.html#t:connection_uri/0"},{"type":"behaviour","doc":"This module allows to consume messages from specified queue bound to specified exchange.Configuration:exchange - specifies an exchange to declare. See Freddy.Core.Exchange for available options. Optional.:queue - specifies a queue to declare. See Freddy.Core.Queue for available options. Mandatory.:qos - configures channel QoS. See Freddy.Core.QoS for available options.:binds - specifies bindings to create from the declared queue to the declared exchange. Must be a list of keywords or %Freddy.Core.Bind{} structs. See Freddy.Core.Bind for available options.:routing_keys - a short way to declare bindings, for example providing a list [&quot;key1&quot;, &quot;key2&quot;] is an equivalent of specifying option [binds: [[routing_key: &quot;key1&quot;], [routing_key: &quot;key2&quot;]]].:consumer - arguments to provide to basic.consume method, see below.Consumer options:consumer_tag - Specifies the identifier for the consumer. The consumer tag is local to a channel, so two clients can use the same consumer tags. If this field is empty the server will generate a unique tag. Default is empty.:no_local - If the :no_local field is set the server will not send messages to the connection that published them. Default is false.:no_ack - If this field is set the server does not expect acknowledgements for messages. That is, when a message is delivered to the client the server assumes the delivery will succeed and immediately dequeues it. This functionality may increase performance but at the cost of reliability. Messages can get lost if a client dies before they are delivered to the application. Defaults to false.:exclusive - Request exclusive consumer access, meaning only this consumer can access the queue. Default is false.:nowait - If set, the server will not respond to the method and client will not wait for a reply. Default is false.:arguments - A set of arguments for the consume. The syntax and semantics of these arguments depends on the server implementation.Exampledefmodule Notifications.Listener do use Freddy.Consumer def start_link(conn, initial \\ nil, opts \\ []) do config = [ exchange: [name: &quot;freddy-topic&quot;, type: :topic], queue: [name: &quot;notifications-queue&quot;, opts: [auto_delete: true]], qos: [prefetch_count: 10], # optional routing_keys: [&quot;routing_key1&quot;, &quot;routing_key2&quot;], # short way to declare binds binds: [ # fully customizable bindings [routing_key: &quot;routing_key3&quot;, no_wait: true] ], consumer: [exclusive: true] # optional ] Freddy.Consumer.start_link(__MODULE__, conn, config, initial, opts) end def init(initial) do # do something on init {:ok, initial} end def handle_message(payload, %{routing_key: &quot;visitor.status.disconnect&quot;}, state) do {:reply, :ack, state} end def handle_error(error, message, _meta) do # log error? {:reply, :nack, state} end end","title":"Freddy.Consumer","ref":"Freddy.Consumer.html"},{"type":"function","doc":"Ack's a message given its meta","title":"Freddy.Consumer.ack/2","ref":"Freddy.Consumer.html#ack/2"},{"type":"function","doc":"See Connection.call/3.","title":"Freddy.Consumer.call/3","ref":"Freddy.Consumer.html#call/3"},{"type":"function","doc":"See Connection.cast/2.","title":"Freddy.Consumer.cast/2","ref":"Freddy.Consumer.html#cast/2"},{"type":"callback","doc":"Called when a message is delivered from the queue before passing it into a handle_message function.The arguments are the message's raw payload, some metatdata and the internal state. The metadata is a map containing all metadata given by the AMQP client when receiving the message plus the :exchange and :queue values.Returning {:ok, payload, state} or {:ok, payload, meta, state} will pass the decoded payload and meta into handle_message/3 function.Returning {:reply, action, opts, state} or {:reply, action, state} will immediately ack, nack or reject the message.Returning {:noreply, state} will do nothing, and therefore the message should be acknowledged by using Freddy.Consumer.ack/2, Freddy.Consumer.nack/2 or Freddy.Consumer.reject/2.Returning {:stop, reason, state} will terminate the main loop and call terminate(reason, state) before the process exits with reason reason.","title":"Freddy.Consumer.decode_message/3","ref":"Freddy.Consumer.html#c:decode_message/3"},{"type":"callback","doc":"Called when the process receives a call message sent by call/3. This callback has the same arguments as the GenServer equivalent and the :reply, :noreply and :stop return tuples behave the same.","title":"Freddy.Consumer.handle_call/3","ref":"Freddy.Consumer.html#c:handle_call/3"},{"type":"callback","doc":"Called when the process receives a cast message sent by cast/2. This callback has the same arguments as the GenServer equivalent and the :noreply and :stop return tuples behave the same.","title":"Freddy.Consumer.handle_cast/2","ref":"Freddy.Consumer.html#c:handle_cast/2"},{"type":"callback","doc":"Called when the Freddy.Consumer process has opened and AMQP channel and declared an exchange and a queue.First argument is a map, containing :channel, :exchange and :queue structures.Returning {:noreply, state} will cause the process to enter the main loop with the given state.Returning {:error, state} will indicate that process failed to perform some critical actions and must reconnect.Returning {:stop, reason, state} will terminate the main loop and call terminate/2 before the process exits with reason reason.","title":"Freddy.Consumer.handle_connected/2","ref":"Freddy.Consumer.html#c:handle_connected/2"},{"type":"callback","doc":"Called when the Freddy.Consumer process has been disconnected from the AMQP broker.Returning {:noreply, state} causes the process to enter the main loop with the given state. The process will not consume any new messages until connection to AMQP broker is established again.Returning {:stop, reason, state} will terminate the main loop and call terminate/2 before the process exits with reason reason.","title":"Freddy.Consumer.handle_disconnected/2","ref":"Freddy.Consumer.html#c:handle_disconnected/2"},{"type":"callback","doc":"Called when the process receives a message. This callback has the same arguments as the GenServer equivalent and the :noreply and :stop return tuples behave the same.","title":"Freddy.Consumer.handle_info/2","ref":"Freddy.Consumer.html#c:handle_info/2"},{"type":"callback","doc":"Called when a message is delivered from the queue.The arguments are the message's decoded payload, some metadata and the internal state. The metadata is a map containing all metadata given by the adapter when receiving the message plus the :exchange and :queue values received at the connect/2 callback.Returning {:reply, :ack | :nack | :reject, state} will ack, nack or reject the message.Returning {:reply, :ack | :nack | :reject, opts, state} will ack, nack or reject the message with the given opts.Returning {:noreply, state} will do nothing, and therefore the message should be acknowledged by using Freddy.Consumer.ack/2, Freddy.Consumer.nack/2 or Freddy.Consumer.reject/2.Returning {:stop, reason, state} will terminate the main loop and call terminate(reason, state) before the process exits with reason reason.","title":"Freddy.Consumer.handle_message/3","ref":"Freddy.Consumer.html#c:handle_message/3"},{"type":"callback","doc":"Called when the AMQP server has registered the process as a consumer and it will start to receive messages.Returning {:noreply, state} will causes the process to enter the main loop with the given state.Returning {:stop, reason, state} will terminate the main loop and call terminate(reason, state) before the process exits with reason reason.","title":"Freddy.Consumer.handle_ready/2","ref":"Freddy.Consumer.html#c:handle_ready/2"},{"type":"callback","doc":"Called when the Freddy.Consumer process is first started.Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and attempt to open a channel on the given connection and initialize an actor (it depends on the actor's nature, consumer will, for example, declare an exchange, a queue and a bindings).After that it will enter the main loop with state as its internal state.Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop, opening a channel or calling terminate/2.Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process will exit with reason reason without entering the loop, opening a channel, or calling terminate/2.","title":"Freddy.Consumer.init/1","ref":"Freddy.Consumer.html#c:init/1"},{"type":"function","doc":"Nack's a message given its meta","title":"Freddy.Consumer.nack/2","ref":"Freddy.Consumer.html#nack/2"},{"type":"function","doc":"Rejects a message given its meta","title":"Freddy.Consumer.reject/2","ref":"Freddy.Consumer.html#reject/2"},{"type":"function","doc":"Start a Freddy.Consumer process without linking to the current process.See start_link/5 for more information.","title":"Freddy.Consumer.start/5","ref":"Freddy.Consumer.html#start/5"},{"type":"function","doc":"Start a Freddy.Consumer process linked to the current process.Arguments:mod - the module that defines the server callbacks (like GenServer)connection - the pid of a Freddy.Connection processconfig - the configuration of the consumerinitial - the value that will be given to init/1opts - the GenServer options","title":"Freddy.Consumer.start_link/5","ref":"Freddy.Consumer.html#start_link/5"},{"type":"function","doc":"See GenServer.stop/2.","title":"Freddy.Consumer.stop/2","ref":"Freddy.Consumer.html#stop/2"},{"type":"callback","doc":"This callback is the same as the GenServer equivalent and is called when the process terminates. The first argument is the reason the process is about to exit with.","title":"Freddy.Consumer.terminate/2","ref":"Freddy.Consumer.html#c:terminate/2"},{"type":"type","doc":"","title":"Freddy.Consumer.action/0","ref":"Freddy.Consumer.html#t:action/0"},{"type":"type","doc":"","title":"Freddy.Consumer.connection/0","ref":"Freddy.Consumer.html#t:connection/0"},{"type":"type","doc":"","title":"Freddy.Consumer.connection_info/0","ref":"Freddy.Consumer.html#t:connection_info/0"},{"type":"type","doc":"","title":"Freddy.Consumer.consumer_options/0","ref":"Freddy.Consumer.html#t:consumer_options/0"},{"type":"type","doc":"","title":"Freddy.Consumer.error/0","ref":"Freddy.Consumer.html#t:error/0"},{"type":"type","doc":"","title":"Freddy.Consumer.meta/0","ref":"Freddy.Consumer.html#t:meta/0"},{"type":"type","doc":"","title":"Freddy.Consumer.payload/0","ref":"Freddy.Consumer.html#t:payload/0"},{"type":"type","doc":"","title":"Freddy.Consumer.routing_key/0","ref":"Freddy.Consumer.html#t:routing_key/0"},{"type":"type","doc":"","title":"Freddy.Consumer.state/0","ref":"Freddy.Consumer.html#t:state/0"},{"type":"module","doc":"Queue-Exchange or Exchange-Exchange binding configirationOptions:routing_key - Specifies the routing key for the binding. The routing key is used for routing messages depending on the exchange configuration. Not all exchanges use a routing key - refer to the specific exchange documentation. Default is &quot;#&quot;.:nowait - If set, the server will not respond to the method and client will not wait for a reply. Default is false.:arguments - A set of arguments for the binding. The syntax and semantics of these arguments depends on the exchange class.Exampleiex&gt; %Freddy.Core.Bind{routing_key: &quot;a_key&quot;}","title":"Freddy.Core.Bind","ref":"Freddy.Core.Bind.html"},{"type":"function","doc":"Create binding configuration from keyword list or Freddy.Core.Bind structure.","title":"Freddy.Core.Bind.new/1","ref":"Freddy.Core.Bind.html#new/1"},{"type":"type","doc":"","title":"Freddy.Core.Bind.t/0","ref":"Freddy.Core.Bind.html#t:t/0"},{"type":"module","doc":"Exchange configuration.Fields:name - Exchange name. If left empty, default exchange will be used.:type - Exchange type. Can be :direct, :topic, :fanout or an arbitrary string, such as &quot;x-delayed-message&quot;. Default is :direct.:opts - Exchange options. See below.Exchange options:durable - If set, keeps the Exchange between restarts of the broker.:auto_delete - If set, deletes the Exchange once all queues unbind from it.:passive - If set, returns an error if the Exchange does not already exist.:internal - If set, the exchange may not be used directly by publishers, but only when bound to other exchanges. Internal exchanges are used to construct wiring that is not visible to applications.:nowait - If set, the server will not respond to the method and client will not wait for a reply. Default is false.:arguments - A set of arguments for the declaration. The syntax and semantics of these arguments depends on the server implementation.Exampleiex&gt; %Freddy.Core.Exchange{name: &quot;freddy-topic&quot;, type: :topic, durable: true}","title":"Freddy.Core.Exchange","ref":"Freddy.Core.Exchange.html"},{"type":"function","doc":"Returns default exchange configuration. Such exchange implicitly exists in RabbitMQ and can't be declared by the clients.","title":"Freddy.Core.Exchange.default/0","ref":"Freddy.Core.Exchange.html#default/0"},{"type":"function","doc":"Create exchange configuration from keyword list or Freddy.Core.Exchange structure.","title":"Freddy.Core.Exchange.new/1","ref":"Freddy.Core.Exchange.html#new/1"},{"type":"type","doc":"","title":"Freddy.Core.Exchange.options/0","ref":"Freddy.Core.Exchange.html#t:options/0"},{"type":"type","doc":"","title":"Freddy.Core.Exchange.t/0","ref":"Freddy.Core.Exchange.html#t:t/0"},{"type":"module","doc":"Channel quality of service configurationFields:prefetch_size - The client can request that messages be sent in advance so that when the client finishes processing a message, the following message is already held locally, rather than needing to be sent down the channel. Prefetching gives a performance improvement. This field specifies the prefetch window size in octets. The server will send a message in advance if it is equal to or smaller in size than the available prefetch size (and also falls into other prefetch limits). May be set to zero, meaning &quot;no specific limit&quot;, although other prefetch limits may still apply. The :prefetch_size is ignored if the no-ack option is set.:prefetch_count - Specifies a prefetch window in terms of whole messages. This field may be used in combination with the :prefetch_size field; a message will only be sent in advance if both prefetch windows (and those at the channel and connection level) allow it. The :prefetch_count is ignored if the no-ack option is set.:global - RabbitMQ takes global=false to mean that the QoS settings should apply per-consumer (for new consumers on the channel; existing ones being unaffected) and global=true to mean that the QoS settings should apply per-channelExampleiex&gt; %Freddy.Core.QoS{prefetch_count: 10}","title":"Freddy.Core.QoS","ref":"Freddy.Core.QoS.html"},{"type":"function","doc":"Returns default configuration for QoS","title":"Freddy.Core.QoS.default/0","ref":"Freddy.Core.QoS.html#default/0"},{"type":"function","doc":"Create QoS configuration from keyword list or Freddy.Core.QoS structure.","title":"Freddy.Core.QoS.new/1","ref":"Freddy.Core.QoS.html#new/1"},{"type":"type","doc":"","title":"Freddy.Core.QoS.default/0","ref":"Freddy.Core.QoS.html#t:default/0"},{"type":"type","doc":"","title":"Freddy.Core.QoS.t/0","ref":"Freddy.Core.QoS.html#t:t/0"},{"type":"type","doc":"","title":"Freddy.Core.QoS.t/3","ref":"Freddy.Core.QoS.html#t:t/3"},{"type":"module","doc":"Queue configurationFields:name - Queue name. If left empty, a server named queue with unique name will be declared.:opts - Queue options, see below.Options:durable - If set, keeps the Queue between restarts of the broker.:auto_delete - If set, deletes the Queue once all subscribers disconnect.:exclusive - If set, only one subscriber can consume from the Queue.:passive - If set, raises an error unless the queue already exists.:nowait - If set, the server will not respond to the method and client will not wait for a reply. Default is false.:arguments - A set of arguments for the declaration. The syntax and semantics of these arguments depends on the server implementation.ExamplesServer-named queueiex&gt; %Freddy.Core.Queue{exclusive: true, auto_delete: true}Client-named queueiex&gt; %Freddy.Core.Queue{name: &quot;notifications&quot;, durable: true}","title":"Freddy.Core.Queue","ref":"Freddy.Core.Queue.html"},{"type":"function","doc":"Create queue configuration from keyword list or Freddy.Core.Queue structure.","title":"Freddy.Core.Queue.new/1","ref":"Freddy.Core.Queue.html#new/1"},{"type":"type","doc":"","title":"Freddy.Core.Queue.options/0","ref":"Freddy.Core.Queue.html#t:options/0"},{"type":"type","doc":"","title":"Freddy.Core.Queue.t/0","ref":"Freddy.Core.Queue.html#t:t/0"},{"type":"behaviour","doc":"A behaviour module for implementing AMQP publisher processes.The Freddy.Publisher module provides a way to create processes that holds, monitors, and restarts a channel in case of failure, exports a function to publish messages to an exchange, and some callbacks to hook into the process lifecycle.An example Freddy.Publisher process that only sends every other message:defmodule MyPublisher do use Freddy.Publisher def start_link(conn, config, opts \\ []) do Freddy.Publisher.start_link(__MODULE__, conn, config, :ok, opts) end def publish(publisher, payload, routing_key) do Freddy.Publisher.publish(publisher, payload, routing_key) end def init(:ok) do {:ok, %{last_ignored: false}} end def before_publication(_payload, _routing_key, _opts, %{last_ignored: false}) do {:ignore, %{last_ignored: true}} end def before_publication(_payload, _routing_key, _opts, %{last_ignored: true}) do {:ok, %{last_ignored: false}} end endChannel handlingWhen the Freddy.Publisher starts with start_link/5 it runs the init/1 callback and responds with {:ok, pid} on success, like a GenServer.After starting the process it attempts to open a channel on the given connection. It monitors the channel, and in case of failure it tries to reopen again and again on the same connection.Context setupThe context setup process for a publisher is to declare its exchange.Every time a channel is opened the context is set up, meaning that the exchange is declared through the new channel based on the given configuration.The configuration must be a Keyword.t that contains a single key: :exchange whose value is the configuration for the Freddy.Core.Exchange.Check Freddy.Core.Exchange for more detailed information.","title":"Freddy.Publisher","ref":"Freddy.Publisher.html"},{"type":"callback","doc":"Called before a message will be encoded and published to the exchange.It receives as argument the message payload, the routing key, the options for that publication and the internal state.Returning {:ok, state} will cause the message to be sent with no modification, and enter the main loop with the given state.Returning {:ok, payload, routing_key, opts, state} will cause the given payload, routing key and options to be used instead of the original ones, and enter the main loop with the given state.Returning {:ignore, state} will ignore that message and enter the main loop again with the given state.Returning {:stop, reason, state} will not send the message, terminate the main loop and call terminate(reason, state) before the process exits with reason reason.","title":"Freddy.Publisher.before_publication/4","ref":"Freddy.Publisher.html#c:before_publication/4"},{"type":"function","doc":"See Connection.call/3.","title":"Freddy.Publisher.call/3","ref":"Freddy.Publisher.html#call/3"},{"type":"function","doc":"See Connection.cast/2.","title":"Freddy.Publisher.cast/2","ref":"Freddy.Publisher.html#cast/2"},{"type":"callback","doc":"Called before a message will be published to the exchange.It receives as argument the message payload, the routing key, the options for that publication and the internal state.Returning {:ok, string, state} will cause the returned string to be published to the exchange, and the process to enter the main loop with the given state.Returning {:ok, string, routing_key, opts, state} will cause the given string, routing key and options to be used instead of the original ones, and enter the main loop with the given state.Returning {:ignore, state} will ignore that message and enter the main loop again with the given state.Returning {:stop, reason, state} will not send the message, terminate the main loop and call terminate(reason, state) before the process exits with reason reason.","title":"Freddy.Publisher.encode_message/4","ref":"Freddy.Publisher.html#c:encode_message/4"},{"type":"callback","doc":"Called when the process receives a call message sent by call/3. This callback has the same arguments as the GenServer equivalent and the :reply, :noreply and :stop return tuples behave the same.","title":"Freddy.Publisher.handle_call/3","ref":"Freddy.Publisher.html#c:handle_call/3"},{"type":"callback","doc":"Called when the process receives a cast message sent by cast/2. This callback has the same arguments as the GenServer equivalent and the :noreply and :stop return tuples behave the same.","title":"Freddy.Publisher.handle_cast/2","ref":"Freddy.Publisher.html#c:handle_cast/2"},{"type":"callback","doc":"Called when the Freddy.Publisher process has opened and AMQP channel and declared an exchange.First argument is a map, containing :channel and :exchange structures.Returning {:noreply, state} will cause the process to enter the main loop with the given state.Returning {:error, state} will indicate that process failed to perform some critical actions and must reconnect.Returning {:stop, reason, state} will terminate the main loop and call terminate/2 before the process exits with reason reason.","title":"Freddy.Publisher.handle_connected/2","ref":"Freddy.Publisher.html#c:handle_connected/2"},{"type":"callback","doc":"Called when the Freddy.Publisher process has been disconnected from the AMQP broker.Returning {:noreply, state} causes the process to enter the main loop with the given state. The process will not consume any new messages until connection to AMQP broker is established again.Returning {:stop, reason, state} will terminate the main loop and call terminate/2 before the process exits with reason reason.","title":"Freddy.Publisher.handle_disconnected/2","ref":"Freddy.Publisher.html#c:handle_disconnected/2"},{"type":"callback","doc":"Called when the process receives a message. This callback has the same arguments as the GenServer equivalent and the :noreply and :stop return tuples behave the same.","title":"Freddy.Publisher.handle_info/2","ref":"Freddy.Publisher.html#c:handle_info/2"},{"type":"callback","doc":"Called when the Freddy.Publisher process is first started.Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and attempt to open a channel on the given connection and initialize an actor (it depends on the actor's nature, consumer will, for example, declare an exchange, a queue and a bindings).After that it will enter the main loop with state as its internal state.Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop, opening a channel or calling terminate/2.Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process will exit with reason reason without entering the loop, opening a channel, or calling terminate/2.","title":"Freddy.Publisher.init/1","ref":"Freddy.Publisher.html#c:init/1"},{"type":"function","doc":"Publishes a message to an exchange through the Freddy.Publisher process or from Freddy.Publisher process using the connection meta information.When publishing from within the publisher process, the connection_info can be obtained from handle_connected/2 callback.Options:mandatory - If set, returns an error if the broker can't route the message to a queue (default false);:immediate - If set, returns an error if the broker can't deliver te message to a consumer immediately (default false);:content_type - MIME Content type;:content_encoding - MIME Content encoding;:headers - Message headers. Can be used with headers Exchanges;:persistent - If set, uses persistent delivery mode. Messages marked as persistent that are delivered to durable queues will be logged to disk;:correlation_id - application correlation identifier;:priority - message priority, ranging from 0 to 9;:reply_to - name of the reply queue;:expiration - how long the message is valid (in milliseconds);:message_id - message identifier;:timestamp - timestamp associated with this message (epoch time);:type - message type as a string;:user_id - creating user ID. RabbitMQ will validate this against the active connection user;:app_id - publishing application ID.","title":"Freddy.Publisher.publish/4","ref":"Freddy.Publisher.html#publish/4"},{"type":"function","doc":"Start a Freddy.Publisher process without linking to the current process.See start_link/5 for more information.","title":"Freddy.Publisher.start/5","ref":"Freddy.Publisher.html#start/5"},{"type":"function","doc":"Start a Freddy.Publisher process linked to the current process.Arguments:mod - the module that defines the server callbacks (like GenServer)connection - the pid of a Freddy.Connection processconfig - the configuration of the consumerinitial - the value that will be given to init/1opts - the GenServer options","title":"Freddy.Publisher.start_link/5","ref":"Freddy.Publisher.html#start_link/5"},{"type":"function","doc":"See GenServer.stop/2.","title":"Freddy.Publisher.stop/2","ref":"Freddy.Publisher.html#stop/2"},{"type":"callback","doc":"This callback is the same as the GenServer equivalent and is called when the process terminates. The first argument is the reason the process is about to exit with.","title":"Freddy.Publisher.terminate/2","ref":"Freddy.Publisher.html#c:terminate/2"},{"type":"type","doc":"","title":"Freddy.Publisher.connection/0","ref":"Freddy.Publisher.html#t:connection/0"},{"type":"type","doc":"","title":"Freddy.Publisher.connection_info/0","ref":"Freddy.Publisher.html#t:connection_info/0"},{"type":"type","doc":"","title":"Freddy.Publisher.consumer_options/0","ref":"Freddy.Publisher.html#t:consumer_options/0"},{"type":"type","doc":"","title":"Freddy.Publisher.meta/0","ref":"Freddy.Publisher.html#t:meta/0"},{"type":"type","doc":"","title":"Freddy.Publisher.payload/0","ref":"Freddy.Publisher.html#t:payload/0"},{"type":"type","doc":"","title":"Freddy.Publisher.routing_key/0","ref":"Freddy.Publisher.html#t:routing_key/0"},{"type":"type","doc":"","title":"Freddy.Publisher.state/0","ref":"Freddy.Publisher.html#t:state/0"},{"type":"behaviour","doc":"This module allows to build RPC client for any Freddy-compliant microservice.Exampledefmodule PaymentsService do use Freddy.RPC.Client @config [timeout: 3500] def start_link(conn, initial, opts \\\\ []) do Freddy.RPC.Client.start_link(__MODULE__, conn, @config, initial, opts) end end {:ok, client} = PaymentsService.start_link() PaymentsService.request(client, &quot;Payments&quot;, %{type: &quot;get_history&quot;, site_id: &quot;xxx&quot;})","title":"Freddy.RPC.Client","ref":"Freddy.RPC.Client.html"},{"type":"callback","doc":"Called before a request will be performed to the exchange.It receives as argument the RPC request structure which contains the message payload, the routing key and the options for that publication, and the internal client state.Returning {:ok, state} will cause the request to be performed with no modification, block the client until the response is received, and enter the main loop with the given state.Returning {:ok, request, state} will cause the payload, routing key and options from the given request to be used instead of the original ones, block the client until the response is received, and enter the main loop with the given state.Returning {:reply, response, state} will respond the client inmediately without performing the request with the given response, and enter the main loop again with the given state.Returning {:stop, reason, response, state} will not send the message, respond to the caller with response, terminate the main loop and call terminate/2 before the process exits with reason reason.Returning {:stop, reason, state} will not send the message, terminate the main loop and call terminate/2 before the process exits with reason reason.","title":"Freddy.RPC.Client.before_request/2","ref":"Freddy.RPC.Client.html#c:before_request/2"},{"type":"function","doc":"See Connection.call/3.","title":"Freddy.RPC.Client.call/3","ref":"Freddy.RPC.Client.html#call/3"},{"type":"function","doc":"See Connection.cast/2.","title":"Freddy.RPC.Client.cast/2","ref":"Freddy.RPC.Client.html#cast/2"},{"type":"callback","doc":"Called when a response message is delivered from the queue before passing it into a on_response function.The arguments are the message's raw payload, response metatdata, original RPC request for which the response has arrived, and the internal state.The metadata is a map containing all metadata given by the AMQP client when receiving the message plus the :exchange and :queue values.Returning {:ok, payload, state} or {:ok, payload, meta, state} will pass the decoded payload and meta into handle_message/3 function.Returning {:noreply, state} will do nothing, and therefore the message should be acknowledged by using Freddy.Consumer.ack/2, Freddy.Consumer.nack/2 or Freddy.Consumer.reject/2.Returning {:stop, reason, state} will terminate the main loop and call terminate/2 before the process exits with reason reason.","title":"Freddy.RPC.Client.decode_response/4","ref":"Freddy.RPC.Client.html#c:decode_response/4"},{"type":"callback","doc":"Called before a message will be published to the exchange.It receives as argument the RPC request structure and the internal state.Returning {:ok, request, state} will cause the returned request to be published to the exchange, and the process to enter the main loop with the given state.Returning {:reply, response, state} will respond the client inmediately without performing the request with the given response, and enter the main loop again with the given state.Returning {:stop, reason, response, state} will not send the message, respond to the caller with response, and terminate the main loop and call terminate/2 before the process exits with reason reason.Returning {:stop, reason, state} will not send the message, terminate the main loop and call terminate/2 before the process exits with reason reason.","title":"Freddy.RPC.Client.encode_request/2","ref":"Freddy.RPC.Client.html#c:encode_request/2"},{"type":"callback","doc":"Called when the process receives a call message sent by call/3. This callback has the same arguments as the GenServer equivalent and the :reply, :noreply and :stop return tuples behave the same.","title":"Freddy.RPC.Client.handle_call/3","ref":"Freddy.RPC.Client.html#c:handle_call/3"},{"type":"callback","doc":"Called when the process receives a cast message sent by cast/2. This callback has the same arguments as the GenServer equivalent and the :noreply and :stop return tuples behave the same.","title":"Freddy.RPC.Client.handle_cast/2","ref":"Freddy.RPC.Client.html#c:handle_cast/2"},{"type":"callback","doc":"Called when the RPC client process has opened AMQP channel before registering itself as a consumer.First argument is a map, containing :channel, :exchange and :queue structures.Returning {:noreply, state} will cause the process to enter the main loop with the given state.Returning {:error, state} will cause the process to reconnect (i.e. open new channel, declare exchange and queue, etc).Returning {:stop, reason, state} will terminate the main loop and call terminate/2 before the process exits with reason reason.","title":"Freddy.RPC.Client.handle_connected/2","ref":"Freddy.RPC.Client.html#c:handle_connected/2"},{"type":"callback","doc":"Called when the AMQP server has been disconnected from the AMQP broker.Returning {:noreply, state} will cause the process to enter the main loop with the given state. The server will not consume any new messages until connection to AMQP broker is restored.Returning {:stop, reason, state} will terminate the main loop and call terminate/2 before the process exits with reason reason.","title":"Freddy.RPC.Client.handle_disconnected/2","ref":"Freddy.RPC.Client.html#c:handle_disconnected/2"},{"type":"callback","doc":"Called when the process receives a message. This callback has the same arguments as the GenServer equivalent and the :noreply and :stop return tuples behave the same.","title":"Freddy.RPC.Client.handle_info/2","ref":"Freddy.RPC.Client.html#c:handle_info/2"},{"type":"callback","doc":"Called when the AMQP server has registered the process as a consumer of the server-named queue and it will start to receive messages.Returning {:noreply, state} will causes the process to enter the main loop with the given state.Returning {:stop, reason, state} will not send the message, terminate the main loop and call terminate/2 before the process exits with reason reason.","title":"Freddy.RPC.Client.handle_ready/2","ref":"Freddy.RPC.Client.html#c:handle_ready/2"},{"type":"callback","doc":"Called when the RPC client process is first started. start_link/5 will block until it returns.It receives as argument the fourth argument given to start_link/5.Returning {:ok, state} will cause start_link/5 to return {:ok, pid} and attempt to open a channel on the given connection, declare the exchange, declare a server-named queue, and consume it. After that it will enter the main loop with state as its internal state.Returning :ignore will cause start_link/5 to return :ignore and the process will exit normally without entering the loop, opening a channel or calling terminate/2.Returning {:stop, reason} will cause start_link/5 to return {:error, reason} and the process will exit with reason reason without entering the loop, opening a channel, or calling terminate/2.","title":"Freddy.RPC.Client.init/1","ref":"Freddy.RPC.Client.html#c:init/1"},{"type":"callback","doc":"Called when a response has been received, before it is delivered to the caller.It receives as argument the decoded and parse response, original RPC request for which the response has arrived, and the internal state.Returning {:reply, reply, state} will cause the given reply to be delivered to the caller instead of the original response, and enter the main loop with the given state.Returning {:noreply, state} will enter the main loop with the given state without responding to the caller (that will eventually timeout or keep blocked forever if the timeout was set to :infinity).Returning {:stop, reason, reply, state} will deliver the given reply to the caller instead of the original response and call terminate/2 before the process exits with reason reason.Returning {:stop, reason, state} not reply to the caller and call terminate/2 before the process exits with reason reason.","title":"Freddy.RPC.Client.on_response/3","ref":"Freddy.RPC.Client.html#c:on_response/3"},{"type":"callback","doc":"Called when a request has been returned by AMPQ broker.Returning {:reply, reply, state} will cause the given reply to be delivered to the caller, and enter the main loop with the given state.Returning {:noreply, state} will enter the main loop with the given state without responding to the caller (that will eventually timeout or keep blocked forever if the timeout was set to :infinity).Returning {:stop, reason, reply, state} will deliver the given reply to the caller, and call terminate/2 before the process exits with reason reason.Returning {:stop, reason, state} will not reply to the caller and call terminate/2 before the process exits with reason reason.","title":"Freddy.RPC.Client.on_return/2","ref":"Freddy.RPC.Client.html#c:on_return/2"},{"type":"callback","doc":"Called when a request has timed out.Returning {:reply, reply, state} will cause the given reply to be delivered to the caller, and enter the main loop with the given state.Returning {:noreply, state} will enter the main loop with the given state without responding to the caller (that will eventually timeout or keep blocked forever if the timeout was set to :infinity).Returning {:stop, reason, reply, state} will deliver the given reply to the caller, and call terminate/2 before the process exits with reason reason.Returning {:stop, reason, state} will not reply to the caller and call terminate/2 before the process exits with reason reason.","title":"Freddy.RPC.Client.on_timeout/2","ref":"Freddy.RPC.Client.html#c:on_timeout/2"},{"type":"function","doc":"Performs a RPC request and blocks until the response arrives.The routing_key parameter specifies the routing key for the message. The routing key is used by the RabbitMQ server to route a message from an exchange to worker queues or another exchanges.The payload parameter specifies the message content as an Erlang term. The payload is converted to binary string by the encode_request/2 callback before sending it to server.Options:timeout - if present, the client is allowed to wait given number of milliseconds for the response message from the server:headers - message headers:persistent - if set, uses persistent delivery mode:priority - message priority, ranging from 0 to 9:message_id - message identifier:timestamp - timestamp associated with this message (epoch time):user_id - creating user ID. RabbitMQ will validate this against the active connection user:app_id - publishing application ID","title":"Freddy.RPC.Client.request/4","ref":"Freddy.RPC.Client.html#request/4"},{"type":"function","doc":"Starts a Freddy.RPC.Client process without linking to the current process, see start_link/5 for more information.","title":"Freddy.RPC.Client.start/5","ref":"Freddy.RPC.Client.html#start/5"},{"type":"function","doc":"Starts a Freddy.RPC.Client process linked to the current process.This function is used to start a Freddy.RPC.Client process in a supervision tree. The process will be started by calling init/1 with the given initial value.Argumentsmod - the module that defines the server callbacks (like in GenServer)connection - the pid of a Freddy.Connection processconfig - the configuration of the RPC Client (describing the exchange and timeout value)initial - the value that will be given to init/1options - the GenServer optionsConfiguration:exchange - a keyword list or %Freddy.Core.Exchange{} structure, describing an exchange that will be used to publish RPC requests to. If not present, the default RabbitMQ exchange will be used. See Freddy.Core.Exchange for available options:timeout - specified default request timeout in milliseconds","title":"Freddy.RPC.Client.start_link/5","ref":"Freddy.RPC.Client.html#start_link/5"},{"type":"function","doc":"See GenServer.stop/2.","title":"Freddy.RPC.Client.stop/2","ref":"Freddy.RPC.Client.html#stop/2"},{"type":"callback","doc":"This callback is the same as the GenServer equivalent and is called when the process terminates. The first argument is the reason the process is about to exit with.","title":"Freddy.RPC.Client.terminate/2","ref":"Freddy.RPC.Client.html#c:terminate/2"},{"type":"type","doc":"","title":"Freddy.RPC.Client.config/0","ref":"Freddy.RPC.Client.html#t:config/0"},{"type":"type","doc":"","title":"Freddy.RPC.Client.meta/0","ref":"Freddy.RPC.Client.html#t:meta/0"},{"type":"type","doc":"","title":"Freddy.RPC.Client.opts/0","ref":"Freddy.RPC.Client.html#t:opts/0"},{"type":"type","doc":"","title":"Freddy.RPC.Client.payload/0","ref":"Freddy.RPC.Client.html#t:payload/0"},{"type":"type","doc":"","title":"Freddy.RPC.Client.request/0","ref":"Freddy.RPC.Client.html#t:request/0"},{"type":"type","doc":"","title":"Freddy.RPC.Client.response/0","ref":"Freddy.RPC.Client.html#t:response/0"},{"type":"type","doc":"","title":"Freddy.RPC.Client.routing_key/0","ref":"Freddy.RPC.Client.html#t:routing_key/0"},{"type":"type","doc":"","title":"Freddy.RPC.Client.state/0","ref":"Freddy.RPC.Client.html#t:state/0"},{"type":"module","doc":"RPC Request data structure. Applications may modify this data structure. For example, one might want to add some specific publication option to every request, or change routing key, based on request payload, or just add some application-specific meta-information.ExamplesPartial implementation of Freddy.RPC.Client behaviour:alias Freddy.RPC.Request def before_request(request, state) do new_request = request |&gt; Request.put_option(:priority, 9) |&gt; Request.put_option(:user_id, Application.get_env(:my_app, :rabbitmq)[:user_id]) |&gt; Request.update_payload(fn %{} = payload -&gt; Map.put(payload, :now, DateTime.utc_now()) {:ok, new_request, state} end def on_response(response, request, state) do Logger.info(&quot;Request \#{request.id} is completed in \#{Request.duration(request)} ms&quot;) {:reply, response, state} end","title":"Freddy.RPC.Request","ref":"Freddy.RPC.Request.html"},{"type":"function","doc":"Get duration of the finished request with the given granularity.","title":"Freddy.RPC.Request.duration/2","ref":"Freddy.RPC.Request.html#duration/2"},{"type":"function","doc":"Get a value with the given key from the request meta-information dictionary. If the key is not set, the default value will be returned.","title":"Freddy.RPC.Request.get_meta/3","ref":"Freddy.RPC.Request.html#get_meta/3"},{"type":"function","doc":"Get value of the existing option of the request. If option is not set, the default value is returned.","title":"Freddy.RPC.Request.get_option/3","ref":"Freddy.RPC.Request.html#get_option/3"},{"type":"function","doc":"Get timeout value of the request.","title":"Freddy.RPC.Request.get_timeout/1","ref":"Freddy.RPC.Request.html#get_timeout/1"},{"type":"function","doc":"Add arbitrary meta information with given key and value to the request. This information is not used by Freddy itself, but can be used by customized clients or servers to carry some additional information throughout the request lifecycle.","title":"Freddy.RPC.Request.put_meta/3","ref":"Freddy.RPC.Request.html#put_meta/3"},{"type":"function","doc":"Add or change existing option of the request.","title":"Freddy.RPC.Request.put_option/3","ref":"Freddy.RPC.Request.html#put_option/3"},{"type":"function","doc":"Remove the existing key from the request meta-information. If the key wasn't set, this action won't have any effect.","title":"Freddy.RPC.Request.remove_meta/2","ref":"Freddy.RPC.Request.html#remove_meta/2"},{"type":"function","doc":"Removes the existing option from the request. If the option wasn't set, this action won't have any effect.","title":"Freddy.RPC.Request.remove_option/2","ref":"Freddy.RPC.Request.html#remove_option/2"},{"type":"function","doc":"Change request payload to new_payload.","title":"Freddy.RPC.Request.set_payload/2","ref":"Freddy.RPC.Request.html#set_payload/2"},{"type":"function","doc":"Change request routing key to new_routing_key.","title":"Freddy.RPC.Request.set_routing_key/2","ref":"Freddy.RPC.Request.html#set_routing_key/2"},{"type":"function","doc":"Change request timeout value. The timeout value can be given as a positive integer, or an :infinity atom. This value will be used by the RPC client to notify requester, that the server hasn't responded within a given timeout milliseconds interval.","title":"Freddy.RPC.Request.set_timeout/2","ref":"Freddy.RPC.Request.html#set_timeout/2"},{"type":"function","doc":"Update request payload with the given function.","title":"Freddy.RPC.Request.update_payload/2","ref":"Freddy.RPC.Request.html#update_payload/2"},{"type":"function","doc":"Update request routing key with the given function.","title":"Freddy.RPC.Request.update_routing_key/2","ref":"Freddy.RPC.Request.html#update_routing_key/2"},{"type":"type","doc":"Request identifier, unique for every request.Applications SHOULD NOT change the generated identifier, but MAY use its value, for example, for logging purposes.","title":"Freddy.RPC.Request.id/0","ref":"Freddy.RPC.Request.html#t:id/0"},{"type":"type","doc":"Request meta information.Applications MAY read and modify meta-information using functions put_meta/3, get_meta/3 and remove_meta/2. Applications SHOULD NOT modify this field directly.","title":"Freddy.RPC.Request.meta/0","ref":"Freddy.RPC.Request.html#t:meta/0"},{"type":"type","doc":"Request options.Applications MAY read and modify request options using functions put_option/3, get_option/3 and remove_option/2. Applications SHOULD NOT modify this field directly.See Freddy.Publisher.publish/4 for available options.","title":"Freddy.RPC.Request.options/0","ref":"Freddy.RPC.Request.html#t:options/0"},{"type":"type","doc":"Request payload.Can be of any type initially. Applications MUST encode this field to a string (binary) before sending the message to server.","title":"Freddy.RPC.Request.payload/0","ref":"Freddy.RPC.Request.html#t:payload/0"},{"type":"type","doc":"Request routing key.Applications MAY modify request routing key using functions set_routing_key/2 and update_routing_key/2.","title":"Freddy.RPC.Request.routing_key/0","ref":"Freddy.RPC.Request.html#t:routing_key/0"},{"type":"type","doc":"","title":"Freddy.RPC.Request.t/0","ref":"Freddy.RPC.Request.html#t:t/0"},{"type":"behaviour","doc":"A behaviour module for implementing AMQP RPC server processes.The Freddy.RPC.Server module provides a way to create processes that hold, monitor, and restart a channel in case of failure, and have some callbacks to hook into the process lifecycle and handle messages.An example Freddy.RPC.Server process that responds messages with &quot;ping&quot; as payload with a &quot;pong&quot; response, otherwise it does not reply but calls a given handler function with the payload and a callback function asynchronously, so the handler can respond when the message is processed:defmodule MyRPC.Server do use Freddy.RPC.Server def start_link(conn, config, handler) do Freddy.RPC.Server.start_link(__MODULE__, conn, config, handler) end def init(handler) do {:ok, %{handler: handler}} end def handle_request(&quot;ping&quot;, _meta, state) do {:reply, &quot;pong&quot;, state} end def handle_request(payload, meta, %{handler: handler} = state) do callback = &amp;Freddy.RPC.Server.reply(meta, &amp;1) Task.start_link(fn -&gt; handler.(payload, callback) end) {:noreply, state} end endChannel handlingWhen the Freddy.RPC.Server starts with start_link/5 it runs the init/1 callback and responds with {:ok, pid} on success, like a GenServer.After starting the process it attempts to open a channel on the given connection. It monitors the channel, and in case of failure it tries to reopen again and again on the same connection.Context setupThe context setup process for a RPC server is to declare an exchange, then declare a queue to consume, and then bind the queue to the exchange. It also creates a default exchange to use it to respond to the reply-to queue.Every time a channel is open the context is set up, meaning that the queue and the exchange are declared and binded through the new channel based on the given configuration.The configuration must be a Keyword.t that contains the same keys as Freddy.Consumer. Check out Freddy.Consumer documentation for the list of available configuration keys.Acknowledgement modeBy default RPC server starts in automatic acknowledgement mode. It means that all incoming requests will be acknowledged automatically by RabbitMQ server once delivered to a client (RPC server process).If your logic requires manual acknowledgements, you should start server with configuration option [consumer: [no_ack: false]] and acknowledge messages manually using ack/2 function.Below is an example of how to start a server in manual acknowledgement mode:defmodule MyRPC.Server do alias Freddy.RPC.Server use Server def start_link(conn, handler) do config = [ queue: [name: &quot;rpc-queue&quot;], consumer: [no_ack: false] ] Server.start_link(__MODULE__, conn, config, handler) end def handle_request(payload, meta, handler) do result = handler.handle_request(payload) Server.ack(meta) {:reply, result, handler} end end","title":"Freddy.RPC.Server","ref":"Freddy.RPC.Server.html"},{"type":"function","doc":"See Freddy.Consumer.ack/2.","title":"Freddy.RPC.Server.ack/2","ref":"Freddy.RPC.Server.html#ack/2"},{"type":"function","doc":"See Freddy.Consumer.call/3.","title":"Freddy.RPC.Server.call/3","ref":"Freddy.RPC.Server.html#call/3"},{"type":"function","doc":"See Freddy.Consumer.cast/2.","title":"Freddy.RPC.Server.cast/2","ref":"Freddy.RPC.Server.html#cast/2"},{"type":"callback","doc":"Called when a request message is delivered from the queue before passing it into a handle_request function.The arguments are the message's payload, some metadata and the internal state.The metadata is a map containing all metadata given by the AMQP client when receiving the message plus the :exchange and :queue values.Returning {:ok, request, state} will pass the returned request term into c:handle_message/3 function.Returning {:ok, request, meta, state} will pass the returned request term and the meta into c:handle_message/3 function.Returning {:reply, response, state} will publish response message without calling c:handle_message/3 function. Function encode_response/3 will be called before publishing the response.Returning {:reply, response, opts, state} will publish the response message with returned options without calling c:handle_message/3 function. Function encode_response/3 will be called before publishing the response.Returning {:noreply, state} will ignore that message and enter the main loop again with the given state.Returning {:stop, reason, state} will terminate the main loop and call terminate/2 before the process exits with reason reason.","title":"Freddy.RPC.Server.decode_request/3","ref":"Freddy.RPC.Server.html#c:decode_request/3"},{"type":"callback","doc":"Called before a response message will be published to the default exchange.It receives as argument the message payload, the options for that publication and the internal state.Returning {:reply, string, state} will cause the returned string to be published to the exchange, and the process to enter the main loop with the given state.Returning {:reply, string, opts, state} will cause the returned string to be published to the exchange with the returned options, and enter the main loop with the given state.Returning {:noreply, state} will ignore that message and enter the main loop again with the given state.Returning {:stop, reason, state} will terminate the main loop and call terminate/2 before the process exits with reason reason.","title":"Freddy.RPC.Server.encode_response/3","ref":"Freddy.RPC.Server.html#c:encode_response/3"},{"type":"callback","doc":"Called when the process receives a call message sent by call/3. This callback has the same arguments as the GenServer equivalent and the :reply, :noreply and :stop return tuples behave the same.","title":"Freddy.RPC.Server.handle_call/3","ref":"Freddy.RPC.Server.html#c:handle_call/3"},{"type":"callback","doc":"Called when the process receives a cast message sent by cast/2. This callback has the same arguments as the GenServer equivalent and the :noreply and :stop return tuples behave the same.","title":"Freddy.RPC.Server.handle_cast/2","ref":"Freddy.RPC.Server.html#c:handle_cast/2"},{"type":"callback","doc":"Called when the RPC server process has opened AMQP channel before registering itself as a consumer.First argument is a map, containing :channel, :exchange and :queue structures.Returning {:noreply, state} will cause the process to enter the main loop with the given state.Returning {:error, state} will cause the process to reconnect (i.e. open new channel, declare exchange and queue, etc).Returning {:stop, reason, state} will terminate the main loop and call terminate/2 before the process exits with reason reason.","title":"Freddy.RPC.Server.handle_connected/2","ref":"Freddy.RPC.Server.html#c:handle_connected/2"},{"type":"callback","doc":"Called when the RPC server has been disconnected from the AMQP broker.Returning {:noreply, state} will cause the process to enter the main loop with the given state. The server will not consume any new messages until connection to AMQP broker is restored.Returning {:stop, reason, state} will terminate the main loop and call terminate/2 before the process exits with reason reason.","title":"Freddy.RPC.Server.handle_disconnected/2","ref":"Freddy.RPC.Server.html#c:handle_disconnected/2"},{"type":"callback","doc":"Called when the process receives a message. This callback has the same arguments as the GenServer equivalent and the :noreply and :stop return tuples behave the same.","title":"Freddy.RPC.Server.handle_info/2","ref":"Freddy.RPC.Server.html#c:handle_info/2"},{"type":"callback","doc":"Called when the AMQP server has registered the process as a consumer of the server-named queue and it will start to receive messages.Returning {:noreply, state} will causes the process to enter the main loop with the given state.Returning {:stop, reason, state} will not send the message, terminate the main loop and call terminate/2 before the process exits with reason reason.","title":"Freddy.RPC.Server.handle_ready/2","ref":"Freddy.RPC.Server.html#c:handle_ready/2"},{"type":"callback","doc":"Called when a request message has been successfully decoded by decode_request/3 function.The arguments are the message's decoded payload, some metadata and the internal state.The metadata is a map containing all metadata given by the AMQP client when receiving the message plus the :exchange and :queue values.Returning {:reply, response, state} will publish response message. Function encode_response/3 will be called before publishing the response.Returning {:reply, response, opts, state} will publish the response message with returned options. Function encode_response/3 will be called before publishing the response.Returning {:noreply, state} will ignore that message and enter the main loop again with the given state.Returning {:stop, reason, state} will terminate the main loop and call terminate/2 before the process exits with reason reason.","title":"Freddy.RPC.Server.handle_request/3","ref":"Freddy.RPC.Server.html#c:handle_request/3"},{"type":"callback","doc":"Called when the RPC server process is first started. start_link/5 will block until it returns.It receives as argument the fourth argument given to start_link/5.Returning {:ok, state} will cause start_link/5 to return {:ok, pid} and attempt to open a channel on the given connection, declare the exchange, declare a queue, and start consumption. After that it will enter the main loop with state as its internal state.Returning :ignore will cause start_link/5 to return :ignore and the process will exit normally without entering the loop, opening a channel or calling terminate/2.Returning {:stop, reason} will cause start_link/5 to return {:error, reason} and the process will exit with reason reason without entering the loop, opening a channel, or calling terminate/2.","title":"Freddy.RPC.Server.init/1","ref":"Freddy.RPC.Server.html#c:init/1"},{"type":"function","doc":"Responds a request given its meta","title":"Freddy.RPC.Server.reply/3","ref":"Freddy.RPC.Server.html#reply/3"},{"type":"function","doc":"Start a Freddy.RPC.Server process without linking to the current process.See start_link/5 for more information.","title":"Freddy.RPC.Server.start/5","ref":"Freddy.RPC.Server.html#start/5"},{"type":"function","doc":"Start a Freddy.RPC.Server process linked to the current process.Arguments:mod - the module that defines the server callbacks (like GenServer)connection - the pid of a Freddy.Connection processconfig - the configuration of the RPC serverinitial - the value that will be given to init/1opts - the GenServer options","title":"Freddy.RPC.Server.start_link/5","ref":"Freddy.RPC.Server.html#start_link/5"},{"type":"function","doc":"See GenServer.stop/2.","title":"Freddy.RPC.Server.stop/2","ref":"Freddy.RPC.Server.html#stop/2"},{"type":"callback","doc":"This callback is the same as the GenServer equivalent and is called when the process terminates. The first argument is the reason the process is about to exit with.","title":"Freddy.RPC.Server.terminate/2","ref":"Freddy.RPC.Server.html#c:terminate/2"},{"type":"type","doc":"","title":"Freddy.RPC.Server.meta/0","ref":"Freddy.RPC.Server.html#t:meta/0"},{"type":"type","doc":"","title":"Freddy.RPC.Server.opts/0","ref":"Freddy.RPC.Server.html#t:opts/0"},{"type":"type","doc":"","title":"Freddy.RPC.Server.payload/0","ref":"Freddy.RPC.Server.html#t:payload/0"},{"type":"type","doc":"","title":"Freddy.RPC.Server.request/0","ref":"Freddy.RPC.Server.html#t:request/0"},{"type":"type","doc":"","title":"Freddy.RPC.Server.response/0","ref":"Freddy.RPC.Server.html#t:response/0"},{"type":"type","doc":"","title":"Freddy.RPC.Server.routing_key/0","ref":"Freddy.RPC.Server.html#t:routing_key/0"},{"type":"type","doc":"","title":"Freddy.RPC.Server.state/0","ref":"Freddy.RPC.Server.html#t:state/0"},{"type":"module","doc":"","title":"Freddy.Tracer","ref":"Freddy.Tracer.html"},{"type":"function","doc":"","title":"Freddy.Tracer.add_context_to_opts/1","ref":"Freddy.Tracer.html#add_context_to_opts/1"},{"type":"function","doc":"","title":"Freddy.Tracer.attach_context_from_opts/1","ref":"Freddy.Tracer.html#attach_context_from_opts/1"},{"type":"function","doc":"","title":"Freddy.Tracer.with_process_span/4","ref":"Freddy.Tracer.html#with_process_span/4"},{"type":"function","doc":"","title":"Freddy.Tracer.with_send_span/3","ref":"Freddy.Tracer.html#with_send_span/3"},{"type":"extras","doc":"FreddyOTP behaviours for creating AMQP publishers and consumers.The project is in active development stage, expect breaking changes between minor versions up to 1.0.","title":"Freddy","ref":"readme.html"},{"type":"extras","doc":"Add freddy to your list of dependencies in mix.exs:def deps do [{:freddy, &quot;~&gt; 0.15.0&quot;}] end","title":"Freddy - Installation","ref":"readme.html#installation"},{"type":"extras","doc":"Neither official RabbitMQ client, nor its Elixir wrapper amqp provide an out-of-box way to create a stable monitored connection to RabbitMQ server, which will be gracefully reestablished after server restart or intermittent network failures.Freddy attempts to provide such abstraction, which is called Freddy.Connection. It is a standard OTP-compliant process that can be easily integrated into OTP supervision tree using standard capabilities.All Freddy behaviors (publishers and consumers) require Freddy.Connection.The connection process can be started like this:{:ok, conn} = Freddy.Connection.start_link(config)Check out Freddy.Connection.start_link/2 for available options.Add this process to an OTP application supervision tree:defmodule MyApp do use Application def start(_type, _args) do import Supervisor.Spec children = [ worker(Freddy.Connection, [[], [name: Freddy.Connection]]) ] opts = [strategy: :one_for_one, name: MyApp.Supervisor] Supervisor.start_link(children, opts) end endWe recommend to start Freddy.Connection and all your publishers and consumers in the OTP supervision tree. Ideally connection and dependent processes should be grouped in one supervisor with restart strategy :rest_for_one.","title":"Freddy - Stable connection","ref":"readme.html#stable-connection"},{"type":"extras","doc":"It is possible to leverage H/A RabbitMQ setup by providing multiple connection options when starting a Freddy.Connection process. Don't forget to specify connection_timeout, or your process may stuck in infinite wait loop.host1 = [host: &quot;10.0.100.1&quot;, connection_timeout: 1000] host2 = [host: &quot;10.0.100.2&quot;, connection_timeout: 1000] host3 = [host: &quot;10.0.100.3&quot;, connection_timeout: 1000] {:ok, conn} = Freddy.Connection.start_link([host1, host2, host3])Freddy.Connection will establish connection to one of the specified hosts, prioritizing them by order of appearing in the list. If it can't establish connection to the first host, it will immediately attempt to establish connection to second, and so on. If none of the hosts are responding, Freddy.Connection will wait a second and attempt to connect to all hosts again.","title":"Freddy - Connection to multiple hosts","ref":"readme.html#connection-to-multiple-hosts"},{"type":"extras","doc":"Freddy provides a behaviour module Freddy.Publisher to implement your own stateful publishers.Check out the behaviour documentation for information about all available callbacks.By default publisher processes encode message payload to JSON before sending the message to RabbitMQ server, it is responsibility of consumers to decode message back. This behaviour can be changed by redefining the default implementation of Freddy.Publisher.encode_message/4 callback.ExampleBelow is an example of how to implement a publishing process that queues up messages when RabbitMQ connection is disrupted (instead of silently dropping them):defmodule ReliableBroadcaster do use Freddy.Publisher @exchange %Freddy.Core.Exchange{name: &quot;notifications&quot;, type: :fanout, opts: [durable: true]} @config [exchange: @exchange] def start_link(connection, opts \\\\ []) do Freddy.Publisher.start_link(__MODULE__, connection, @config, nil, opts) end @impl true def init(_) do state = %{connected: false, queue: :queue.new()} {:ok, state} end @impl true # This function is called after an exchange has been declared def handle_connected(meta, %{queue: queue} = state) do new_state = %{state | connected: true, queue: drain_queue(queue, meta)} {:noreply, new_state} end @impl true # This function is called right after disconnect def handle_disconnected(_reason, state) do {:noreply, %{state | connected: false}} end @impl true # Catch messages before publication and queue them up if connection is not available def before_publication( payload, routing_key, opts, %{connected: connected?, queue: queue} = state ) do if not connected? do message = {payload, routing_key, opts} {:ignore, %{state | queue: :queue.in(message, queue)}} else {:ok, state} end end defp drain_queue(queue, meta) do case :queue.out(queue) do {{:value, {payload, routing_key, opts}}, new_queue} -&gt; Freddy.Publisher.publish(meta, payload, routing_key, opts) drain_queue(new_queue, meta) {:empty, empty_queue} -&gt; empty_queue end end end","title":"Freddy - Publishers","ref":"readme.html#publishers"},{"type":"extras","doc":"Stateful consumer processes are implemented with Freddy.Consumer behaviour module.Check out the behaviour documentation for information about all available callbacks.Consumer process typically works as follows:After initialization consumer opens an AMQP channelAn exchange and a queue are declared using the opened channelThe declared queue is bound to the exchange (see RabbitMQ routing tutorial),The consumer process starts consumption from the queueBroker confirms that consumer process is registered on the serverMessages from the queue are delivered to the consumer processWhen consumer has successfully processed a message, it acknowledges the message on server, and the server removes the message from the queue.Message formatBy default consumer processes assume that incoming messages payload are encoded into JSON and decode them before starting processing. This behaviour can be changed by redefining the default implementation of Freddy.Consumer.decode_message/3 callback.ExampleThis is an example of a process that creates an exclusive queue with server-generated name, binds this queue to fanout exchange &quot;notifications&quot; and processes each message in a separate asynchronous task.Please note that as we process messages asynchronously and we don't consume messages with :no_ack option, we must explicitly acknowledge or reject processed messages using Freddy.Consumer.ack/2 or Freddy.Consumer.reject/2.The chosen approach is very naive and we do not recommend to use this code in production, it is here only for educational purposes.defmodule NotificationsProcessor do use Freddy.Consumer @config [ exchange: [name: &quot;notifications&quot;, type: :fanout], queue: [opts: [exclusive: true, auto_delete: true]], qos: [prefetch_count: 10], routing_keys: [&quot;#&quot;] ] def start_link(conn, handler_mfa) do Freddy.Consumer.start_link(__MODULE__, conn, @config, handler_mfa) end @impl true def init(handler) do {:ok, handler} end @impl true def handle_message(payload, %{routing_key: key} = meta, {m, f, a} = handler) do Task.start_link(fn -&gt; try do apply(m, f, [payload, key | a]) Freddy.Consumer.ack(meta) rescue _error -&gt; # we might want to log error here too Freddy.Consumer.reject(meta, requeue: true) end end) {:noreply, state} end end","title":"Freddy - Consumers","ref":"readme.html#consumers"},{"type":"extras","doc":"ClientRPC Client in a nutshell is a combination of consumer and publisher. A process publishes RPC requests into default or any other exchange and expects a server to publish response message to a special anonymous queue from which an RPC client process consumes.Each request contains a name of reply queue and a correlation ID - an identifier which allows RPC client to understand for which request the response has arrived. When server sends a reply, it publishes a message into default exchange with a routing key equal to the name of the client reply queue and copies correlation ID from the request to the response message.A diagram below illustrates an RPC request-response lifecycle: +------------+ +----------------+ | Client |------------&gt;| Pub exchange | +------------+ +----------------+ ^ | | | | v +-------------+ +----------------+ | Reply queue | | Server queue | +-------------+ +----------------+ ^ | | | | v +----------------+ +----------------+ |Default exchange|&lt;----------| RPC Server | +----------------+ +----------------+Freddy.RPC.Client is also implemented as behaviour module, leaving you an opportunity to customize your application logic through set of callback functions.Check out Freddy.RPC.Client documentation for information about available callbacks.ExampleThis is an example of RPC client that publishes requests to the default exchange, logs unsuccessful requests and emits response time to a StatsD server.defmodule RPC.Client do use Freddy.RPC.Client require Logger alias Freddy.RPC.Request @server_queue &quot;RemoteService&quot; def start_link(conn, opts \\\\ []) do Freddy.RPC.Client.start_link(__MODULE__, conn, [], nil, opts) end def request(client, payload) do Freddy.RPC.Client.request(client, @server_queue, payload) end @impl true def on_timeout(request, state) do Logger.warn(&quot;Request to server \#{request.routing_key} timed out after \#{Request.duration(request)} ms&quot;) {:reply, {:error, :timeout}, state} end @impl true def on_return(request, state) do Logger.warn(&quot;Request to server \#{request.routing_key} couldn&#39;t be routed&quot;) {:reply, {:error, :no_route}, state} end @impl true def on_response(response, request, state) do send_metrics(request) {:reply, response, state} end defp send_metrics(request) do MyApp.Statix.histogram(&quot;rpc.request&quot;, Request.duration(request), tags: [&quot;server:\#{request.routing_key}&quot;]) end endTestingWe recommend you to structure your code in such way that your test environment will not use real RPC client.For example, you can create a client behavior and use Mox to mock all calls to a client. This way you can test how your code communicates with RPC client. Please refer to Mox documentation for more information about mocks and explicit contracts.If you need to test RPC client itself, you can hook into request lifecycle and use before_request/2 callback to return required responses. It is recommended to use fake connection in test environment:defmodule MockClient do use Freddy.RPC.Client def start_link(conn) do Freddy.RPC.Client.start_link(__MODULE__, conn, [], []) end def flush(client) do Freddy.RPC.Client.call(client, :flush) end def before_request(request, sink) do {:reply, :ok, [request | sink]} end def handle_call(:flush, sink) do {:reply, Enum.reverse(sink), []} end endAnd use it in tests:test &quot;sends an RPC request&quot; do {:ok, conn} = Freddy.Connection.start_link(adapter: :sandbox) {:ok, client} = MockClient.start_link(conn) MyLib.call(client: client) assert [%{routing_key: &quot;server&quot;}] = MockClient.flush(client) endServerSimilarly to RPC client, RPC server is also a combination of consumer and publisher, but on the server side, the consumer is used to accept RPC request messages, whilst the publisher is used to send back response messages.Check out Freddy.RPC.Server documentation for information about available callbacks.Message formatBy default server processes assume that incoming messages payload are encoded into JSON and decode them before processing. This behaviour can be changed by redefining the default implementation of Freddy.RPC.Server.decode_request/3 callback.Acknowledgement modeBy default RPC server starts in automatic acknowledgement mode. It means that all incoming requests will be acknowledged automatically by RabbitMQ server once delivered to a client (RPC server process).If your logic requires manual acknowledgements, you should start server with configuration option [consumer: [no_ack: false]] and acknowledge messages manually using Freddy.RPC.Server.ack/2 function.ExampleBelow is an example of simple synchronous echo RPC server, which can process only one request at a time:defmodule RPC.Server do use Freddy.RPC.Server def start_link(conn) do config = [ queue: [name: &quot;EchoServer&quot;] ] Freddy.RPC.Server.start_link(__MODULE__, conn, config, []) end def handle_request(payload, _meta, state) do {:reply, payload, state} end endA slightly more complicated example of asynchronous RPC server, which processes every request in a separate process with manual acknowledgement of processed requests:defmodule RPC.Server do use Freddy.RPC.Server import Freddy.RPC.Server, only: [ack: 1, reply: 2] def start_link(conn, handler) when is_function(handler, 1) do config = [ queue: [name: &quot;AsyncServer&quot;], qos: [prefetch_count: 100], # this is protection from DoS consumer: [no_ack: false] # this enables manual acknowledgements ] Freddy.RPC.Server.start_link(__MODULE__, conn, config, handler) end @impl true def init(handler) do {:ok, task_sup} = Task.Supervisor.start_link() {:ok, {task_sup, handler}} end @impl true def handle_request(request, meta, {task_sup, handler}} = state) do Task.Supervisor.start_child(task_sup, fn -&gt; result = handler.(request) ack(meta) reply(meta, result) end) {:noreply, state} end end","title":"Freddy - Remote Procedure Call (RPC)","ref":"readme.html#remote-procedure-call-rpc"}]